//+------------------------------------------------------------------+
//|                                                           11.mq4 |
//|                                                                * |
//|                                                                * |
//+------------------------------------------------------------------+
#property copyright "*"
#property link      "*"

#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color1 Red
#property indicator_color2 Yellow
#property indicator_color3 Red
#property indicator_color4 Red
#property indicator_color5 Red
#property indicator_color6 Red
#property indicator_color7 Red
#property indicator_color8 Red

#property indicator_width1 3

extern double  PARAMETER=0.5;

int FFTPower=8;  //     .   8  256 .
#define Pi 3.14159265358979323846
#define TwoPi 6.28318530717958647692

int FFTPeriod;
double FFTTmpOutput_1[];
double FFTSpectr[][3];
double FFTTmpOutput_2[];
double FFTPprocessedData[];
double FFTDC,FFTStartVShift;

double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double ExtMapBuffer5[];
double ExtMapBuffer6[];
double ExtMapBuffer7[];
double ExtMapBuffer8[];

double Signal[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init(){

   fFFTInit(FFTPower,FFTPeriod,FFTTmpOutput_1,FFTSpectr,FFTTmpOutput_2,FFTPprocessedData);
   ArrayResize(Signal,FFTPeriod);

//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexBuffer(3,ExtMapBuffer4);
   SetIndexStyle(4,DRAW_LINE);
   SetIndexBuffer(4,ExtMapBuffer5);
   SetIndexStyle(5,DRAW_LINE);
   SetIndexBuffer(5,ExtMapBuffer6);
   SetIndexStyle(6,DRAW_LINE);
   SetIndexBuffer(6,ExtMapBuffer7);
   SetIndexStyle(7,DRAW_LINE);
   SetIndexBuffer(7,ExtMapBuffer8);
   SetIndexShift(1,FFTPeriod);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start(){

         static bool f=false;
         if(f)return;
         f=true;

         for(int i=0;i<FFTPeriod;i++){
            Signal[i]=MathSin(PARAMETER*TwoPi/(FFTPeriod)*i);
            ExtMapBuffer1[i]=Signal[i];
         }

      fFFTDirectMain(Signal,0,FFTPeriod,FFTTmpOutput_1);
      fFFTDirectConvertToSpectr(FFTTmpOutput_1,FFTPeriod,FFTSpectr,FFTDC,FFTStartVShift);
         for(int x=0;x<1024;x++){
            ExtMapBuffer2[x]=FFTDC;
            for(i=0;i<256;i++){
               ExtMapBuffer2[x]+=FFTSpectr[i][0]*MathCos(TwoPi/(FFTPeriod)*x*(i)-FFTSpectr[i][1]);
            }            //
         }
              
   return(0);
  }
//+------------------------------------------------------------------+



void fFFTInit(int aFFTPower,int & aPeriod,double & aTmpOutput_1[],double & aSpectr[][2],double & aTmpOutput_2[],double & aFFTPprocessedData[]){
   aPeriod=MathPow(2,FFTPower);
   ArrayResize(aTmpOutput_1,aPeriod);
   ArrayResize(aSpectr,aPeriod/2);
   ArrayResize(aTmpOutput_2,aPeriod);   
   ArrayResize(FFTPprocessedData,aPeriod);   
}

void fFFTDirectMain(double aInput[],int aInputStart,int aPeriod,double & aTmpOutput[]){
   
   double twr; double twi; double twpr; double twpi; double twtemp; double ttheta; int i; int i1; int i2; int i3; int i4; 
   double c1; double c2; double h1r; double h1i; double h2r; double h2i; double wrs; double wis; int HalfPeriod; int ii; 
   int jj; int n; int mmax; int m; int j; int istep; int isign; double wtemp; double wr; double wpr; double wpi; double wi; 
   double theta; double tempr; double tempi;
   
   ttheta=2.0*Pi/aPeriod;
   c1=0.5;
   c2=-0.5;
   isign=1;
   n=aPeriod;
   HalfPeriod=aPeriod/2;
   j=1;
   ArrayCopy(aTmpOutput,aInput,0,aInputStart,aPeriod);
      for(ii=1;ii<=HalfPeriod;ii++){
        i=2*ii-1;
            if(j>i){
               tempr=aTmpOutput[j-1];
               tempi=aTmpOutput[j];
               aTmpOutput[j-1]=aTmpOutput[i-1];
               aTmpOutput[j]=aTmpOutput[i];
               aTmpOutput[i-1]=tempr;
               aTmpOutput[i]=tempi;
            }
         m=n/2;
            while(m>=2 && j>m){
               j=j-m;
               m=m/2;
            }
         j=j+m;
      }
    mmax = 2;
      while(n>mmax){
        istep=2*mmax;
        theta=2.0*Pi/(isign*mmax);
        wpr=-2.0*MathPow(MathSin(0.5*theta),2);
        wpi=MathSin(theta);
        wr=1.0;
        wi=0.0;
            for(ii=1;ii<=mmax/2;ii++){
               m=2*ii-1;
                  for(jj=0;jj<=(n-m)/istep;jj++){
                     i=m+jj*istep;
                     j=i+mmax;
                     tempr=wr*aTmpOutput[j-1]-wi*aTmpOutput[j];
                     tempi=wr*aTmpOutput[j]+wi*aTmpOutput[j-1];
                     aTmpOutput[j-1]=aTmpOutput[i-1]-tempr;
                     aTmpOutput[j]=aTmpOutput[i]-tempi;
                     aTmpOutput[i-1]=aTmpOutput[i-1]+tempr;
                     aTmpOutput[i]=aTmpOutput[i]+tempi;
                  }
               wtemp=wr;
               wr=wr*wpr-wi*wpi+wr;
               wi=wi*wpr+wtemp*wpi+wi;
            }
        mmax = istep;
      }
   twpr=-2.0*MathPow(MathSin(0.5*ttheta),2);
   twpi=MathSin(ttheta);
   twr=1.0+twpr;
   twi=twpi;
        for(i=2;i<=aPeriod/4+1;i++){
            i1=i+i-2;
            i2=i1+1;
            i3=aPeriod+1-i2;
            i4=i3+1;
            wrs=twr;
            wis=twi;
            h1r=c1*(aTmpOutput[i1]+aTmpOutput[i3]);
            h1i=c1*(aTmpOutput[i2]-aTmpOutput[i4]);
            h2r=-c2*(aTmpOutput[i2]+aTmpOutput[i4]);
            h2i=c2*(aTmpOutput[i1]-aTmpOutput[i3]);
            aTmpOutput[i1]=h1r+wrs*h2r-wis*h2i;
            aTmpOutput[i2]=h1i+wrs*h2i+wis*h2r;
            aTmpOutput[i3]=h1r-wrs*h2r+wis*h2i;
            aTmpOutput[i4]=-h1i+wrs*h2i+wis*h2r;
            twtemp=twr;
            twr=twr*twpr-twi*twpi+twr;
            twi=twi*twpr+twtemp*twpi+twi;
        }
   h1r=aTmpOutput[0];
   aTmpOutput[0]=h1r+aTmpOutput[1];
   aTmpOutput[1]=h1r-aTmpOutput[1];   
   return;
}

void fFFTDirectConvertToSpectr(double aInput[],int aPeriod,double & aOutput[][2],double & aDCValue,double & aStartVShift){
   int i,j,HalfPeriod;
   HalfPeriod=aPeriod/2;
      for(i=2,j=1;i<aPeriod;i+=2,j++){
         aOutput[j][0]=MathSqrt(aInput[i]*aInput[i]+aInput[i+1]*aInput[i+1])/HalfPeriod;
         aOutput[j][1]=fMyArcTan2(aInput[i+1],aInput[i]);
      }
   aDCValue=aInput[0]/aPeriod;
   aStartVShift=aInput[1];
}



double fMyArcTan2(double aY,double aX){ //   
   if(aY==0){
      if(aX==0){
         return(0);   
      }
      if(aX>0){
         return(0);   
      }      
      if(aX<0){
         return(MathArctan(1)*4);   
      }      
   }
   if(aX==0){
      if(aY>0){
         return(MathArctan(1)*2);
      }
      else{
         if(aY<0){
            return(-MathArctan(1)*2);         
         }
      }
   }
   else{
      if(aY>0){
         if(aX>0){
            return(MathArctan(aY/aX));  
         }
         else{
            return(MathArctan(aY/aX)+MathArctan(1)*4);          
         }   
      }
      else{
         if(aX>0){
            return(MathArctan(aY/aX));           
         }
         else{
            return(MathArctan(aY/aX)-MathArctan(1)*4);           
         }      
      }
   }
}



